Index: trunk/expressoMail1_2/inc/get_archive.php
===================================================================
--- trunk/expressoMail1_2/inc/get_archive.php	(revision 5069)
+++ trunk/expressoMail1_2/inc/get_archive.php	(revision 5134)
@@ -1,40 +1,3 @@
 <?php
-/**
-*
-* Copyright (C) 2011 Consórcio Expresso Livre - 4Linux (www.4linux.com.br) e Prognus Software Livre (www.prognus.com.br)
-*
-* This program is free software; you can redistribute it and/or modify it under
-* the terms of the GNU Affero General Public License version 3 as published by
-* the Free Software Foundation with the addition of the following permission
-* added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
-* WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
-* WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
-*
-* This program is distributed in the hope that it will be useful, but WITHOUT
-* ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
-* FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
-* details.
-*
-* You should have received a copy of the GNU Affero General Public License
-* along with this program; if not, see www.gnu.org/licenses or write to
-* the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
-* MA 02110-1301 USA.
-*
-* This code is based on the OpenXchange Connector and on the Prognus pSync
-* Connector both developed by the community and licensed under the GPL
-* version 2 or above as published by the Free Software Foundation.
-*
-* You can contact Prognus Software Livre headquarters at Av. Tancredo Neves,
-* 6731, PTI, Bl. 05, Esp. 02, Sl. 10, Foz do Iguaçu - PR - Brasil or at
-* e-mail address prognus@prognus.com.br.
-*
-*
-* @package    expressoMail
-* @license    http://www.gnu.org/copyleft/gpl.html GPL
-* @author     Consórcio Expresso Livre - 4Linux (www.4linux.com.br) e Prognus Software Livre (www.prognus.com.br)
-* @version    1.0
-* @sponsor    Caixa Econômica Federal
-*/
-
 /*
  * Definitions
@@ -52,9 +15,4 @@
 //-----------------------//
 
-/*
- * Requires
- */
-require_once 'class.attachment.inc.php';
-require_once '../../header.inc.php';
 //-----------------------//
 
@@ -62,183 +20,223 @@
  * Get variables
  */
-$newFilename = urldecode($_GET['newFilename']);
-$indexFile = $_GET['idx_file'];
+if(array_key_exists('newFilename', $_GET ) && urldecode($_GET['newFilename']) !== 'application.octet-stream')
+	$newFilename = urldecode($_GET['newFilename']);
+else
+	$newFilename = null;
+if(array_key_exists('idx_file', $_GET ))
+	$indexFile = $_GET['idx_file'];
+else
+	$indexFile = null;
+
 $indexPart = $_GET['indexPart'];
 $msgNumber = $_GET['msgNumber'];
 $msgFolder = $_GET['msgFolder'];
+if(array_key_exists('fileType', $_GET ))
+	$ContentType = $_GET['fileType'];
+else
+	$ContentType = null;
+if(array_key_exists('image', $_GET ))
+	$image = $_GET['image'];
+else
+	$image = null;
 //----------------------------------------------//
 
-
-/**
-* Método que faz o download do arquivo
-*
-* @license    http://www.gnu.org/copyleft/gpl.html GPL
-* @author     Consórcio Expresso Livre - 4Linux (www.4linux.com.br) e Prognus Software Livre (www.prognus.com.br)
-* @sponsor    Caixa Econômica Federal
-* @param  $strFileType
-* @param  $strFileName
-* @param  $newFileName
-* @param  $fileContent
-*/
-function downloadFile($strFileType, $strFileName, $newFileName, $fileContent) {
-
-        $ContentType = "application/octet-stream";
-
-        if ($strFileType == ".asf")
-                $ContentType = "video/x-ms-asf";
-        if ($strFileType == ".avi")
-                $ContentType = "video/avi";
-        if ($strFileType == ".doc")
-                $ContentType = "application/msword";
-        if ($strFileType == ".zip")
-                $ContentType = "application/zip";
-        if ($strFileType == ".xls")
-                $ContentType = "application/vnd.ms-excel";
-        if ($strFileType == ".gif")
-                $ContentType = "image/gif";
-        if ($strFileType == ".jpg" || $strFileType == "jpeg")
-                $ContentType = "image/jpeg";
-        if ($strFileType == ".wav")
-                $ContentType = "audio/wav";
-        if ($strFileType == ".mp3")
-                $ContentType = "audio/mpeg3";
-        if ($strFileType == ".mpg" || $strFileType == "mpeg")
-                $ContentType = "video/mpeg";
-        if ($strFileType == ".rtf")
-                $ContentType = "application/rtf";
-        if ($strFileType == ".htm" || $strFileType == "html")
-                $ContentType = "text/html";
-        if ($strFileType == ".xml")
-                $ContentType = "text/xml";
-        if ($strFileType == ".xsl")
-                $ContentType = "text/xsl";
-        if ($strFileType == ".css")
-                $ContentType = "text/css";
-        if ($strFileType == ".php")
-                $ContentType = "text/php";
-        if ($strFileType == ".asp")
-                $ContentType = "text/asp";
-        if ($strFileType == ".pdf")
-                $ContentType = "application/pdf";
-        if ($strFileType == ".txt")
-                $ContentType = "text/plain";
-        if ($strFileType == ".log")
-                $ContentType = "text/plain";
-        if ($strFileType == ".wmv")
-                $ContentType = "video/x-ms-wmv";
-        if ($strFileType == ".sxc")
-                $ContentType = "application/vnd.sun.xml.calc";
-        if ($strFileType == ".odt")
-                $ContentType = "application/vnd.oasis.opendocument.text";
-        if ($strFileType == ".stc")
-                $ContentType = "application/vnd.sun.xml.calc.template";
-        if ($strFileType == ".sxd")
-                $ContentType = "application/vnd.sun.xml.draw";
-        if ($strFileType == ".std")
-                $ContentType = "application/vnd.sun.xml.draw.template";
-        if ($strFileType == ".sxi")
-                $ContentType = "application/vnd.sun.xml.impress";
-        if ($strFileType == ".sti")
-                $ContentType = "application/vnd.sun.xml.impress.template";
-        if ($strFileType == ".sxm")
-                $ContentType = "application/vnd.sun.xml.math";
-        if ($strFileType == ".sxw")
-                $ContentType = "application/vnd.sun.xml.writer";
-        if ($strFileType == ".sxq")
-                $ContentType = "application/vnd.sun.xml.writer.global";
-        if ($strFileType == ".stw")
-                $ContentType = "application/vnd.sun.xml.writer.template";
-        if ($strFileType == ".ps")
-                $ContentType = "application/postscript";
-        if ($strFileType == ".pps")
-                $ContentType = "application/vnd.ms-powerpoint";
-        if ($strFileType == ".odt")
-                $ContentType = "application/vnd.oasis.opendocument.text";
-        if ($strFileType == ".ott")
-                $ContentType = "application/vnd.oasis.opendocument.text-template";
-        if ($strFileType == ".oth")
-                $ContentType = "application/vnd.oasis.opendocument.text-web";
-        if ($strFileType == ".odm")
-                $ContentType = "application/vnd.oasis.opendocument.text-master";
-        if ($strFileType == ".odg")
-                $ContentType = "application/vnd.oasis.opendocument.graphics";
-        if ($strFileType == ".otg")
-                $ContentType = "application/vnd.oasis.opendocument.graphics-template";
-        if ($strFileType == ".odp")
-                $ContentType = "application/vnd.oasis.opendocument.presentation";
-        if ($strFileType == ".otp")
-                $ContentType = "application/vnd.oasis.opendocument.presentation-template";
-        if ($strFileType == ".ods")
-                $ContentType = "application/vnd.oasis.opendocument.spreadsheet";
-        if ($strFileType == ".ots")
-                $ContentType = "application/vnd.oasis.opendocument.spreadsheet-template";
-        if ($strFileType == ".odc")
-                $ContentType = "application/vnd.oasis.opendocument.chart";
-        if ($strFileType == ".odf")
-                $ContentType = "application/vnd.oasis.opendocument.formula";
-        if ($strFileType == ".odi")
-                $ContentType = "application/vnd.oasis.opendocument.image";
-        if ($strFileType == ".ndl")
-                $ContentType = "application/vnd.lotus-notes";
-        if ($strFileType == ".eml")
-                $ContentType = "text/plain";
-
-        header ("Content-Type: $ContentType");
-        header("Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0");
-        header("Pragma: public");
-        header("Expires: 0"); // set expiration time
-        header ("Content-Disposition: attachment; filename=\"". addslashes($newFileName)."\"");
-
-        if($fileContent)
+/*
+ * Requires
+ */
+if( $indexFile )
+    require_once '../../header.inc.php';
+else
+    require_once '../../header.session.inc.php';
+
+
+/*
+ * Functions
+ */
+
+function unhtmlentities($string)
+{
+    $string = utf8_encode($string);
+    
+    static $trans_tbl;
+ 
+    $string = preg_replace('~&#x([0-9a-f]+);~ei', 'code2utf(hexdec("\\1"))', $string);
+    $string = preg_replace('~&#([0-9]+);~e', 'code2utf(\\1)', $string);
+
+    if (!isset($trans_tbl))
         {
-          echo $fileContent;
+        $trans_tbl = array();
+       
+        foreach (get_html_translation_table(HTML_ENTITIES) as $val=>$key)
+            $trans_tbl[$key] = utf8_encode($val);
         }
-        else
-        {
-                $tempDir = $GLOBALS['phpgw_info']['server']['download_temp_dir'];
-                if (preg_match("#^".$tempDir."/(".$GLOBALS['phpgw']->session->sessionid."/)*[A-z0-9_]+_".$GLOBALS['phpgw']->session->sessionid."[A-z0-9]*(\.[A-z]{3,4})?$#",$strFileName))
-                {
-                //avoid stuck request
-                        session_write_close();
-
-                        //reset time limit for big files
-                        set_time_limit(0);
-                        ob_end_flush();
-
-                        if ($fp = fopen ($strFileName, 'rb'))
-                        {
-                                $bufferSize=1024;
-                                for ($i=$bufferSize; $i<=(filesize($strFileName)+$bufferSize); $i+=$bufferSize)
+    return strtr($string, $trans_tbl);
+}
+
+function code2utf($num)
+{
+    if ($num < 128) return chr($num);
+    if ($num < 2048) return chr(($num >> 6) + 192) . chr(($num & 63) + 128);
+    if ($num < 65536) return chr(($num >> 12) + 224) . chr((($num >> 6) & 63) + 128) . chr(($num & 63) + 128);
+    if ($num < 2097152) return chr(($num >> 18) + 240) . chr((($num >> 12) & 63) + 128) . chr((($num >> 6) & 63) + 128) . chr(($num & 63) + 128);
+    return '';
+}
+
+//-----------------------//
+
+/*
+ * Main
+ */
+
+
+if($msgNumber != 'null' && $indexPart !== null && $msgFolder)
+{
+    require_once $_SESSION['rootPath'].'/expressoMail1_2/inc/class.attachment.inc.php';
+
+    $attachment = new attachment();
+    $attachment->setStructureFromMail($msgFolder, $msgNumber);
+    $fileContent = $attachment->getAttachment($indexPart);
+    $info = $attachment->getAttachmentInfo($indexPart);
+    $filename = $newFilename ? $newFilename : $info['name'];       
+    $filename = unhtmlentities($filename);
+}
+else
+{
+    if( $image && $_SESSION['phpgw_info']['expressomail']['contact_photo'] )
                                 {
-                                        echo fread($fp, $i);
-                                        flush();
-                                }
-                                fclose ($fp);
-                        }
-
-                        //removendo pelo php, garante a suportabilidade cross-platform
-                        cleanup( dirname( $strFileName ) );
-
+	$image = "thumbnail";
+
+	$photo = array( 'width' => 60, 'height' => 80, 'quality' => 100 );
+
+	$fileContent = $_SESSION['phpgw_info']['expressomail']['contact_photo'][0];
+	unset( $_SESSION['phpgw_info']['expressomail']['contact_photo'] );
                 }
+
+    $filename = $indexFile;
+}
+
+$filename = $filename 	? $filename 	: "attachment.bin";
+$newFilename = $newFilename ? $newFilename 	: $filename;
+$newFilename = unhtmlentities($newFilename);
+$disposition = $image ? "inline" : "attachment; filename=\"". addslashes($newFilename)."\"";
+
+if( !$ContentType || $ContentType == 'application/octet-stream')
+{
+    
+    if( strstr($_SERVER['HTTP_USER_AGENT'],'MSIE') && $disposition != 'inline' )
+        $ContentType = 'application-download';
                 else
                 {
-                        if (preg_match("#^".dirname( __FILE__ ) . '/../tmpLclAtt'."/source_#",$strFileName)) {
-                                readfile($strFileName);
+        function guessContentType( $fileName )
+        {
+            $strFileType = strtolower(substr ( $fileName , strrpos($fileName, '.') ));
+                         
+	    switch( $strFileType )
+	    {
+		case ".asf": return "video/x-ms-asf";
+		case ".avi": return "video/avi";
+		case ".doc": return "application/msword";
+		case ".zip": return "application/zip";
+		case ".xls": return "application/vnd.ms-excel";
+		case ".gif": return "image/gif";
+                case ".bmp": return "image/bmp";
+		case ".jpeg":
+		case ".jpg": return "image/jpeg";
+		case ".wav": return "audio/wav";
+		case ".mp3": return "audio/mpeg3";
+		case ".mpeg":
+		case ".mpg": return "video/mpeg";
+		case ".rtf": return "application/rtf";
+		case ".html":
+		case ".htm": return "text/html";
+		case ".xml": return "text/xml";
+		case ".xsl": return "text/xsl";
+		case ".css": return "text/css";
+		case ".php": return "text/php";
+		case ".asp": return "text/asp";
+		case ".pdf": return "application/pdf";
+		case ".png": return "image/png";
+		case ".txt": return "text/plain";
+		case ".log": return "text/plain";
+		case ".wmv": return "video/x-ms-wmv";
+		case ".sxc": return "application/vnd.sun.xml.calc";
+		case ".odt": return "application/vnd.oasis.opendocument.text";
+		case ".stc": return "application/vnd.sun.xml.calc.template";
+		case ".sxd": return "application/vnd.sun.xml.draw";
+		case ".std": return "application/vnd.sun.xml.draw.template";
+		case ".sxi": return "application/vnd.sun.xml.impress";
+		case ".sti": return "application/vnd.sun.xml.impress.template";
+		case ".sxm": return "application/vnd.sun.xml.math";
+		case ".sxw": return "application/vnd.sun.xml.writer";
+		case ".sxq": return "application/vnd.sun.xml.writer.global";
+		case ".stw": return "application/vnd.sun.xml.writer.template";
+		case ".pps": return "application/vnd.ms-powerpoint";
+		case ".odt": return "application/vnd.oasis.opendocument.text";
+		case ".ott": return "application/vnd.oasis.opendocument.text-template";
+		case ".oth": return "application/vnd.oasis.opendocument.text-web";
+		case ".odm": return "application/vnd.oasis.opendocument.text-master";
+		case ".odg": return "application/vnd.oasis.opendocument.graphics";
+		case ".otg": return "application/vnd.oasis.opendocument.graphics-template";
+		case ".odp": return "application/vnd.oasis.opendocument.presentation";
+		case ".otp": return "application/vnd.oasis.opendocument.presentation-template";
+		case ".ods": return "application/vnd.oasis.opendocument.spreadsheet";
+		case ".ots": return "application/vnd.oasis.opendocument.spreadsheet-template";
+		case ".odc": return "application/vnd.oasis.opendocument.chart";
+		case ".odf": return "application/vnd.oasis.opendocument.formula";
+		case ".odi": return "application/vnd.oasis.opendocument.image";
+		case ".ndl": return "application/vnd.lotus-notes";
+		case ".eml": return "text/plain";
+		case ".ps" : return "application/postscript";
+		default    : return "application/octet-stream";
                         }
                 }
+
+        $ContentType = guessContentType( $filename );
         }
 }
 
-
-/**
-* Método que limpa o diretório
-*
-* @license    http://www.gnu.org/copyleft/gpl.html GPL
-* @author     Consórcio Expresso Livre - 4Linux (www.4linux.com.br) e Prognus Software Livre (www.prognus.com.br)
-* @sponsor    Caixa Econômica Federal
-* @param  $dir
-*/
-function cleanup( $dir )
-{
+header("Content-Type: $ContentType");
+header("Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0");
+header("Pragma: public");
+header("Expires: 0"); // set expiration time
+header("Content-Disposition: $disposition");
+
+if( $fileContent )
+{
+    header("Content-transfer-encoding: ".$info["encoding"] );
+
+    if( $image === "thumbnail" )
+    {
+	$pic = imagecreatefromstring( $fileContent );
+
+	if( $pic )
+	{
+	    $width = imagesx($pic);
+	    $height = imagesy($pic);
+
+	    if(!isset($photo))
+			$photo = array( 'width' => 160, 'height' => max( ( 160 * $height / $width ), 1 ) );
+
+	    $thumb = imagecreatetruecolor( $photo['width'], $photo['height'] );
+
+	    if(array_key_exists('quality', $photo)  && $photo['quality'] )
+			imagecopyresampled($thumb, $pic, 0, 0, 0, 0, $photo['width'], $photo['height'], $width, $height);
+	    else
+		imagecopyresized($thumb, $pic, 0, 0, 0, 0, $photo['width'], $photo['height'], $width, $height); # resize image into thumb
+
+	    imagejpeg( $thumb,"", 100 ); # Thumbnail as JPEG
+	}
+    }
+    else
+	echo $fileContent;
+}
+else
+{
+    /**
+    * Delete Diretorio
+    * @param string $dir 
+    */
+    function cleanup( $dir )
+    {
     if ( is_dir( $dir ) )
     {
@@ -260,40 +258,28 @@
     }
 
-}
-//-----------------------//
-
-/*
- * Main
- */
-
-
-if($msgNumber != 'null' && $indexPart !== null && $msgFolder)
-{
-
-    $attachment = new attachment(PHPGW_INCLUDE_ROOT);
-    $attachment->setStructureFromMail($msgFolder, $msgNumber);
-    $fileContent = $attachment->getAttachment($indexPart);
-
-    if($newFilename)
-        $filename = $newFilename;
+    }
+
+    $tempDir = $GLOBALS['phpgw_info']['server']['download_temp_dir'];
+
+    if (preg_match("#^".$tempDir."/(".$GLOBALS['phpgw']->session->sessionid."/)*[A-z0-9_]+_".$GLOBALS['phpgw']->session->sessionid."[A-z0-9]*(\.[A-z]{3,4})?$#",$filename))
+    {
+        session_write_close();
+        set_time_limit(0);
+        ob_clean();
+        flush();
+        readfile($filename);
+
+        //removendo pelo php, garante a suportabilidade cross-platform
+	cleanup(  $filename  );
+
+    }
     else
     {
-        $info = $attachment->getAttachmentInfo($indexPart);
-        $filename = $info['name'];
-    }
-
-
-}
-else
-    $filename = $indexFile;
-
-
-$filename 	 = $filename 	? $filename 	: "attachment.bin";
-$newFilename = $newFilename ? $newFilename 	: $filename;
-
-
-$strFileType = strrev(substr(strrev(strtolower($filename)),0,4));
-
-downloadFile($strFileType,  $filename, $newFilename, $fileContent)
+	    if (preg_match("#^".dirname( __FILE__ ) . '/../tmpLclAtt'."/source_#",$filename)) {
+		    readfile($filename);
+	    }
+    }
+}
+
 //-----------------------//
 
Index: trunk/expressoMail1_2/inc/class.ldap_functions.inc.php
===================================================================
--- trunk/expressoMail1_2/inc/class.ldap_functions.inc.php	(revision 5075)
+++ trunk/expressoMail1_2/inc/class.ldap_functions.inc.php	(revision 5134)
@@ -24,4 +24,5 @@
 		@include("../contactcenter/setup/external_catalogs.inc.php");
 		$this->ldapService = ServiceLocator::getService('ldap');
+		if(isset($external_srcs))
 		$this->external_srcs = $external_srcs;
 		$this->max_result = $this->ldapService->limit;
@@ -65,5 +66,5 @@
 		ldap_set_option($ds, LDAP_OPT_REFERRALS, $refer);
 		if ($refer)
-			ldap_set_rebind_proc($ds, ldapRebind);
+			ldap_set_rebind_proc($ds, 'rebind');
 		@ldap_bind($ds, $_SESSION['phpgw_info']['expressomail']['ldap_server']['acc'],$_SESSION['phpgw_info']['expressomail']['ldap_server']['pw']);
 
@@ -88,18 +89,4 @@
 		$functions = new functions;
 
-//		$search_for	= utf8_encode($params['search_for']);
-  //Testa se a busca foi realizada com aspas
-		$search_for	= utf8_encode($params['search_for']);
-                $search_len = (strlen($search_for)) - 1;
-                $quote_status=false;
-
-                if((($search_for{0}) == "\"") && (($search_for{$search_len}) == "\"")){
-                    $search_for{0} = " ";
-                    $search_for{$search_len} = " ";
-                    $quote_status=true;
-                }
-
-
-
 		$field		= $params['field'];
 		$ID			= $params['ID'];
@@ -118,30 +105,5 @@
 		if ($this->ds)
 		{
-			if (($field != 'null') && ($ID != 'null'))
-			{
-				$filter="(& (&(|(phpgwAccountType=u)(phpgwAccountType=g)(phpgwAccountType=l))(mail=*)) (|(cn=*$search_for*)(mail=*$search_for*)) (!(phpgwaccountvisible=-1)) )";
-				if($extendedinfo)
-				$justthese = array("cn", "mail", "telephoneNumber", "mobile", "phpgwAccountVisible", "uid", "employeeNumber", "ou");
-				else
-				    $justthese = array("cn", "mail", "telephoneNumber", "mobile", "phpgwAccountVisible", "uid");
-			}
-			else
-			{
-				if($quote_status){
-                                	$filter="(& (phpgwAccountType=u) (|(cn=* $search_for *)(cn=$search_for *)(cn=* $search_for)) (!(phpgwaccountvisible=-1)) )";
-                            	}
-                            	else{
-					$filter="(& (phpgwAccountType=u)(cn=*$search_for*) (!(phpgwaccountvisible=-1)) )";
-                            	}
-			//	$filter="(& (phpgwAccountType=u)(cn=*$search_for*) (!(phpgwaccountvisible=-1)) )";
-				if($extendedinfo)
-				$justthese = array("cn", "mail", "telephoneNumber", "mobile", "phpgwAccountVisible","jpegPhoto", "uid", "employeeNumber", "ou");
-				else
-				    $justthese = array("cn", "mail", "telephoneNumber", "mobile", "phpgwAccountVisible","jpegPhoto", "uid");
-			}
-			$sr=@ldap_search($this->ds, $this->ldap_context, $filter, $justthese, 0, $this->max_result + 1);
-			if(!$sr)
-				return null;
-			$count_entries = ldap_count_entries($this->ds,$sr);
+                    $ldapService->connection = $this->ds;
 
                 $justthese = array("cn", "mail", "telephonenumber", "mobile", "phpgwaccountvisible", "uid", "employeenumber", "ou");
@@ -301,9 +263,4 @@
              
             include_once $_SESSION['rootPath']. '/header.inc.php';
-            
-                      
-            if (stripos( $params['search_for'] , '@' ) !== false) 
-                $params['search_for'] = substr($params['search_for'], 0 , stripos( $params['search_for'] , '@' ) ); 
-            
             
             if($modal)
@@ -383,4 +340,8 @@
                 $results['type_catalog'] = "P";
             $results['search_for'] = $params['search_for'];
+			
+			foreach($results as $i=>$value)
+				$results[$i]['type_contact'] = "P";
+			
 			return $results;
         } 
@@ -408,5 +369,5 @@
                 if (is_numeric($parts[3]) && $parts[1]=='attribute')
                 {    
-                    if($parts[2] == 'searchable' && $value == 'true')
+                    if($parts[2] == 'searchable' /*&& $value == 'true'*/)
                         $searchable_fields[$all_data['cc_attribute_ldapname_' . $parts[3]]] = $all_data['cc_attribute_name_' . $parts[3]];   
                 }
@@ -485,4 +446,7 @@
             $info_return['search_for'] = $params['search_for'];
 			$info_return['extra_ldap_fields'] = $campos_extras; 
+			
+			foreach($info_return as $i=>$value)
+				$info_return[$i]['type_contact'] = "G";
             return $info_return;
         } 
@@ -640,23 +604,33 @@
 			$_SESSION['phpgw_info']['expressomail']['server']['ldap_root_pw']);
 
-			$groups = $ldapService->accountSearch($params['filter'], array("gidNumber","cn"), $params['context'] , 'g', 'cn'); 
-			$users = $ldapService->accountSearch($params['filter'], array("uidNumber","cn"), $params['context'] , 'u', 'cn');
+			$groups = $ldapService->accountSearch($params['filter'], array("gidNumber","cn", 'uid'), $params['context'] , 'g', 'cn'); 
+			$users = $ldapService->accountSearch($params['filter'], array("uidNumber","cn", 'uid'), $params['context'] , 'u', 'cn');
+			$compartilhadas = $ldapService->accountSearch($params['filter'], array("uidNumber","cn",'uid'), $params['context'] , 's', 'cn');
+			
+
 			$group_options = array();
 			$user_options  = array();
+			$shared_options = array();
+
 			foreach($groups as $group)
 	        {
-				$group_options[] = '"'.$group['gidNumber'].'U'.'":"'.$group['cn'].'"';
+	                	$group_options[] = '"'.$group['gidnumber'].'U'.'":"'.$group['cn'].' ('.$group['uid'].')"';
 	        }
-
 	        foreach($users as $user) 
 	            {
-				if($owner != $user['uidNumber'])
-					$user_options[] = '"'.$user['uidNumber'].'U'.'":"'.$user['cn'].'"';
+	            		if($owner != $user['uidnumber'])  
+			                $user_options[] = '"'.$user['uidnumber'].'U'.'":"'.$user['cn'].' ('.$user['uid'].')"';
+		        }	
+        		foreach($compartilhadas as $shared)
+                	{
+	            		if($owner != $shared['uidnumber'])  
+			                $shared_options[] = '"'.$shared['uidnumber'].'U'.'":"'.$shared['cn'].' ('.$shared['uid'].')"';
 	            }
 	
 			$user_options = '{'.implode( ',', $user_options ).'}';
 			$group_options = '{'.implode( ',', $group_options ).'}';
-
-	        return array("users" => $user_options, "groups" => $group_options);
+	                $shared_options = '{'.implode( ',', $shared_options ).'}';
+
+	         return '{"users":'.$user_options.',"groups":'.$group_options.',"shared":'. $shared_options .'}';
         }
 
@@ -996,4 +970,154 @@
 		return false;
 	}
+	
+	function get_user_groups($uid)
+	{
+
+		$organizations = array();
+	
+		$this->ldapRootConnect();
+
+                $justthese = array("gidnumber","cn");
+                $filter="(&(phpgwAccountType=g)(memberuid=".$uid."))";
+
+                $search = ldap_search($this->ds, $this->ldap_context, $filter, $justthese);
+
+                $result = array();
+                $entries = ldap_get_entries($this->ds, $search);
+
+
+                for ($i=0; $i<$entries['count']; $i++)
+                {
+                        $result[ $entries[$i]['gidnumber'][0] ] = $entries[$i]['cn'][0];
+                }
+
+		return $result;
+	}
+        
+       function getMailByUid($pUid)
+        {
+                // do not follow the referral
+                $this->ldapRootConnect(false);
+                if ($this->ds)
+                {
+                        $filter="(&(|(phpgwAccountType=u)(phpgwAccountType=s)(phpgwAccountType=l))(uid=$pUid))";
+                        $justthese = array("mail");
+                        $sr=@ldap_search($this->ds, $this->ldap_context, $filter, $justthese);
+                        if(!$sr)
+                                return false;
+                        $info = ldap_get_entries($this->ds, $sr);
+
+
+                        return utf8_decode($info[0]["mail"][0]);
+                }
+                return false;
+        } 
+  
+        function mail2uid($mail)
+	{
+                if(!$this-ds)
+                    $this->ldapRootConnect(false);
+
+                $filter="(&(|(phpgwAccountType=u)(phpgwAccountType=s)(phpgwAccountType=i)(phpgwAccountType=g))(mail=$mail))";
+                $justthese = array("uid");
+                $sr=@ldap_search($this->ds, $this->ldap_context, $filter, $justthese);
+                if(!$sr)
+                    return false;
+                $info = ldap_get_entries($this->ds, $sr);
+                return $info[0]["uid"][0];
+	}
+
+        
+        /**
+         * Retorna as contas compartilhas
+         * @param string $toaddress emails
+         * @param string $ccaddress emails
+         * @param string $ccoaddress emails
+         * @param array $groups array com os grupos que o usuario pertence
+         * @return array
+         */
+        function returnSharedsAccounts($toaddress,$ccaddress,$ccoaddress)
+        {
+
+          $arrayAllAddres = array();
+          $arrayAllAddres =  array_merge($arrayAllAddres , explode(',',$toaddress));
+          $arrayAllAddres =  array_merge($arrayAllAddres, explode(',',$ccaddress));
+          $arrayAllAddres = array_merge($arrayAllAddres, explode(',',$ccoaddress));
+
+          $mailsArray = array();
+
+           foreach ($arrayAllAddres as $toAddres)
+           {
+
+               if(strchr($toAddres,'@') && strchr($toAddres,'<') && strchr($toAddres,'>'))
+               {
+                    $alias = substr($toAddres, strpos($toAddres,'<'), strpos($toAddres,'>'));
+                    $alias = str_replace('<','', str_replace('>','',$alias));
+                    array_push($mailsArray, $alias);
+               }
+               else if(strchr($toAddres,'@'))
+               {
+                    array_push($mailsArray, $toAddres);
+               }
+           }
+           $arraySharedAccounts = array();
+
+           $conexao = $this->ldapConnect2(true);
+
+
+           $mailFilter = '';
+
+           foreach ($mailsArray as $mail)
+             $mailFilter .= '(|(mail='.$mail.')(mailAlternateAddress='.$mail.'))';
+
+
+           $filter = '(&(phpgwAccountType=s)(|'.$mailFilter.') )';
+           $ldap_context = $_SESSION['phpgw_info']['expressomail']['server']['ldap_context'];
+           $justthese = array('cn','uid','mail');
+
+           if ($conexao)
+           {
+                $search = @ldap_search($conexao, $ldap_context, $filter, $justthese);
+                if($search)
+                {
+                    $results = ldap_get_entries($conexao, $search);
+
+                    foreach ($results as $result)
+                    {
+                        if($result['mail'][0])
+                            array_push($arraySharedAccounts, $result['mail'][0]);
+                    }
+                }
+
+           }
+
+           return $arraySharedAccounts;
+        }
+        /**
+        * Verifica se um email é uma conta compartilhada
+        *
+        * @license    http://www.gnu.org/copyleft/gpl.html GPL
+        * @author     Cons?rcio Expresso Livre - 4Linux (www.4linux.com.br) e Prognus Software Livre (www.prognus.com.br)
+        * @author     Cristiano Corrêa Schmidt
+        * @param      String $mail Email a ser verificado
+        * @return     bolean
+        * @access     public
+        */
+        function isSharedAccountByMail($mail)
+        {
+            $return = false;
+            $conexao = $this->ldapConnect2(true);
+            $filter = '(&(phpgwAccountType=s)(mail='.$mail.'))';
+            $ldap_context = $_SESSION['phpgw_info']['expressomail']['server']['ldap_context'];
+            $justthese = array('cn','uid','mail');
+            if ($conexao)
+            {
+                $search = @ldap_search($conexao, $ldap_context, $filter, $justthese);
+                if(ldap_count_entries ($conexao , $search))
+                    $return = true;
+            }
+
+            return $return;
+        }
 }
 ?>
